=== debian/changelog ===
hepmc3 (3.1.1-1) unstable; urgency=medium

  [ Andrii Verbytskyi ]
  * Initial release of HepMC-3.1.1 for Debian

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 28 Apr 2019 03:48:37 +0000
