=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS  = hardenning=+all
export DEB_LDFLGAS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ -Scmake

#We don't have root6 on Debian
override_dh_auto_configure:
	dh_auto_configure -- \
		-DHEPMC3_ENABLE_ROOTIO=OFF \
		-DHEPMC3_ENABLE_TEST=ON \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_SKIP_INSTALL_RPATH=ON \
		-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	cd doc/doxygen; doxygen Doxyfile

override_dh_installdocs:
	dh_installdocs
	dh_doxygen
